// contact me if you need help understanding the functions, xeen
Cc=Components.classes;
Ci=Components.interfaces;

var rdr = {
  preventClean: false,
  overLink: null,
  lastLink: "",
  prefServ: Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService),
  fixup: Cc["@mozilla.org/docshell/urifixup;1"].getService(Ci.nsIURIFixup),
  hist: Cc["@mozilla.org/browser/global-history;2"].getService(Ci.nsIGlobalHistory2),
  // Adds all kinds of observers & injects code in order to clean links
	init: function (all) {    
    window.removeEventListener("load",function() { rdr.init(true); }, false);    
    window.addEventListener("unload", function() { rdr.prefs = null; }, false); 
    
    rdr.locale=rdr.getById("rdrlocale");
    
    rdr.prefs=rdr.prefServ.getBranch('extensions.rdr.');
    rdr.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		rdr.prefs.addObserver("", this, false);    
    rdr.updatePrefs();
    
    if(all) {    
      getBrowser().addEventListener("click", rdr.catchClick, true);
      getBrowser().addEventListener("mousedown", rdr.catchMouseDown, true);
      if(rdr.getById("context-copylink")) rdr.getById("context-copylink").setAttribute("oncommand", "rdr.resetLink();goDoCommand('cmd_copyLink')"); // 3.0
      if(rdr.getById("cmd_copyLink")) {
        rdr.getById("cmd_copyLink").setAttribute("oncommand", "rdr.resetLink();goDoCommand('cmd_copyLink')"); // 2.0
        rdr.is20=true;
      } 
      
      var context=rdr.getById("contentAreaContextMenu");
      if(context) {
        context.addEventListener("popupshowing", function(event) { rdr.contextMenuCheck(event); }, false);
        context.addEventListener("popuphiding",  function(event) { rdr.contextMenuClean(event); }, false);
      }
      
      var appcontent = rdr.getById("appcontent");
      if(appcontent) appcontent.addEventListener("DOMContentLoaded", rdr.cleanImgs, true);
      
      // Code injecting functions need to be delayed
      window.setTimeout("rdr.delayedInit();",9);  
      
      window.addEventListener("mousemove", rdr.cleanLastLink, false);
    }
	},
  
  cleanLastLink: function(evt) {
    if(!rdr.lastLink && rdr.overLink) {
      rdr.overLink.style.cursor="";
      rdr.overLink=null;
    }
    if(!rdr.lastLink) return;
    var linkNode=rdr.getLinkNode(evt.target);
    if(!linkNode || !linkNode.hasAttribute("href")) {
      rdr.postLinkToStatusBar(rdr.lastLink);
      return;
    }  
    
    var cleanedLink=linkNode.href==rdr.lastLinkHref ? rdr.lastLinkCleaned : unescape(rdr.removeR(linkNode.href,true));
    rdr.postLinkToStatusBar(cleanedLink,true);
    rdr.lastLinkCleaned=cleanedLink;
    rdr.lastLinkHref=linkNode.href;
    
    if(linkNode.href!=cleanedLink && rdr.changeCursor) {
      rdr.overLink=linkNode;
      linkNode.style.cursor = "url(chrome://rdr/skin/rdrmouse.png), pointer";
    }
  },
  
  postLinkToStatusBar: function(link,app) {
    var sbText = rdr.getById("statusbar-display");
    var text = (link && app?"RDR: ":"")+link;
    if(sbText.label!=text) sbText.label=text;
  },
  
  getById: function(t) {
    return document.getElementById(t);
  },
  
  delayedInit: function() {     
    // For URLs in the statusbar
    if(nsBrowserStatusHandler) {
      eval("nsBrowserStatusHandler.prototype.setOverLink="+nsBrowserStatusHandler.prototype.setOverLink.toString().replace(
      'this.overLink = link;',
      'if(rdr.matchLinkFast(link)) { rdr.lastLink=link; return; } if(!link) rdr.resetLink(true); if(rdr.lastLink) { rdr.lastLink=""; rdr.postLinkToStatusBar(""); } this.overLink = link;'
      ));
      // "link" is already escaped, making correct cleaning impossible. If a redirect exists, my own listener will handle it.
      // Reset Link after Drag&Drop
    }
    
    try {
      // TabMix function "open multiple links". 
      if(window.openMultipleLinks) {
        eval("openMultipleLinks="+openMultipleLinks.toString().replace(
        'newTab =',
        'nextEpisode.href=rdr.cleanLink(nextEpisode.href); newTab ='
        ));
      } 
    } catch(e){}
        
    try {
      // AiO-Gestures should use cleaned links 
      if(window.aioGetHRef) {
        eval("aioGetHRef="+aioGetHRef.toString().replace(
        'node.href',
        'rdr.cleanLink(node.href);'
        ));
        eval("aioGetHRef="+aioGetHRef.toString().replace(
        'makeURLAbsolute(node.baseURI, node.getAttributeNS(xlinkNS, "href"))',
        'rdr.cleanLink(makeURLAbsolute(node.baseURI, node.getAttributeNS(xlinkNS, "href")));'
        ));
      }
    } catch(e){}
    
    try {
      // Smart Middle Click shouldn't open links if RDR can do it instead
      if(window.contentAreaClick2) {
        eval("contentAreaClick2="+contentAreaClick2.toString().replace(
        'wrapper = linkNode;',
        'wrapper = linkNode; '+
        'if(wrapper.href!=rdr.cleanLink(wrapper.href)) return false;'
        ));
      } 
    } catch(e){}
  },
  
  catchMouseDown: function(aEvt) {
    if (aEvt.button==0) {
		  var wrapper=rdr.getLinkNode(aEvt.originalTarget);
      if(!wrapper || !wrapper.hasAttribute("href")) return;
      var clean=rdr.cleanLink(wrapper.href);
      if(clean==wrapper.href) return false;
      
      rdr.origlinkURL2=new Array(wrapper,wrapper.href);
      wrapper.href=clean;  
    }
  },
    
  catchClick: function(aEvt) {
    if (aEvt.button!= 2 && rdr.contentAreaClick(aEvt)) // button=2 == right click
		  aEvt.stopPropagation();
  },
  
  isLinkElement: function(a) {
    return ((a instanceof HTMLAnchorElement || a instanceof HTMLAreaElement || a instanceof HTMLLinkElement) && a.hasAttribute("href"));
  },
  
  getLinkNode: function(target) {
    var linkNode = false;
       
    if (rdr.isLinkElement(target)) return target;

    var parent = target.parentNode;
    while (parent) {
      if (rdr.isLinkElement(parent)) return parent;
      parent = parent.parentNode;
    }
    return false;
  },
    
  contentAreaClick: function(event) {
    if(rdr.preventClean) return false;
    
    linkNode=rdr.getLinkNode(event.originalTarget);
        
  	var wrapper = null;
  	if (!linkNode) return false;

    wrapper = linkNode;

    clean=rdr.cleanLink(wrapper.href);
    if(clean==wrapper.href) return false;

    // Add uncleaned link to history as well, so it's displayed as visited
    rdr.addURLToHistory(wrapper.href,linkNode);
    
    rdr.origlinkURL=new Array(wrapper,wrapper.href);
    window.setTimeout("rdr.resetLink();",0);
    
    wrapper.href=clean;
    handleLinkClick(event, clean, wrapper);  
    return true;
  },
  
  addURLToHistory: function(url,node) {
    uri = rdr.fixup.createFixupURI(url, 0);
    if (!rdr.hist.isVisited(uri)) {
      rdr.hist.addURI(uri, false, true, null);
      var oldHref = node.getAttribute("href");
      if (typeof oldHref == "string") {
        node.setAttribute("href", "");
        node.setAttribute("href", oldHref);
      }
    }
    return url;
  },
    
  cleanImgs: function(e) {
    var doc = e.originalTarget;
    if(doc.nodeName != "#document" || !rdr.cleanImgsOnLoad || !doc.images || doc.images.length==0) return;
    for(var i=0;i<doc.images.length;i++) {
      tmp=rdr.cleanLink(doc.images[i].src);
      if(doc.images[i] && tmp!=doc.images[i].src) {
        doc.images[i].setAttribute("origsrc",doc.images[i].src);
        doc.images[i].setAttribute("src",tmp);
      }
    }
  },
   
  updatePrefs: function() {
    var t = rdr.prefs.getCharPref("whitelist").toLowerCase();
    rdr.whitelist        = t.length?t.split(" "):new Array();
    rdr.contextWhitelist = rdr.prefs.getBoolPref("contextmenu.whitelist");
    rdr.contextCopyClean = rdr.prefs.getBoolPref("contextmenu.copyclean");
    rdr.contextOpen      = rdr.prefs.getBoolPref("contextmenu.contextopen");
    rdr.contextOpenIn    = rdr.prefs.getIntPref ("contextmenu.contextopen.in");
    rdr.cleanImgsOnLoad  = rdr.prefs.getBoolPref("cleanImages");
    rdr.statusButton     = rdr.prefs.getBoolPref("statusbutton");
    rdr.enabled          = rdr.prefs.getBoolPref("enabled");
    rdr.debug            = rdr.prefs.getBoolPref("debug");
    rdr.askBeforeRemoval = rdr.prefs.getBoolPref("askBeforeRemoval");
    rdr.intelliWhitelist = rdr.prefs.getBoolPref("intelliWhitelist");
    rdr.blacklist        = rdr.prefs.getBoolPref("blacklist");
    rdr.changeCursor     = rdr.prefs.getBoolPref("changeCursor");
        
    try {
      var b=rdr.getById('rdr-button');    
      b.setAttribute('isenabled',rdr.enabled);
      b.setAttribute('label',rdr.locale.getString(rdr.enabled?"rdrIsOn":"rdrIsOff"));
    } catch(e) {}
     
    b=rdr.getById('rdr-status-button');   
    if(!b) return;    
    if(rdr.statusButton) {
      b.setAttribute('isenabled',rdr.enabled);
      b.setAttribute('hidden','false');
      b.setAttribute('collapsed','false');
    } else {
      b.setAttribute('hidden','true');
      b.setAttribute('collapsed','true');
    } 
  },
  
  catchFrames: function(e,arr) {
		arr[arr.length]=e.document;
		if (!("frames" in e) || e.frames.length <= 0) return arr;
	  for (var f = 0; f < e.frames.length; f++)
			try { arr=rdr.catchFrames(e.frames[f],arr);	} catch(e) { }		
		return arr;
  },
  
  handleButtonClick: function(event,sbar) {
    rdr.lastStatusClick=event.button;
    switch(event.button) {
      case 0:
        if(sbar) rdr.prefs.setBoolPref('enabled',!rdr.enabled);
        break;
      case 1:
        rdr.openOptions();
        break;
      case 2:
        event.target.firstChild.showPopup();
    }
    return false;
  },
  
  buttonMenuCheck: function(event) {
    rdr.lastStatusClick=0;
    ev=event.target;  
    rdr.menu=ev;
    // Clean previous entries
    while(x=ev.firstChild) ev.removeChild(x);

    hasItems=false;
    showedHosts=' ';
    try {
      frames=rdr.catchFrames(content,new Array());
      for(var f=0;f<frames.length;f++) {
        links=frames[f].links;
        for(var i=0;i<links.length;i++) {
          if(links[i].href==rdr.removeR(links[i].href)) continue;
          showedHosts=rdr.addMenuItem(ev,links[i].href,links[i],showedHosts);
          hasItems=true;
        }   
          
        if(rdr.cleanImgsOnLoad) { 
          imgs=frames[f].images;
          for(var i=0;i<imgs.length;i++) {
            // Prevent fakes by webmasters
            origSrc=imgs[i].hasAttribute("origsrc");
            if((origSrc && imgs[i].src==rdr.removeR(imgs[i].getAttribute("origsrc"))) || imgs[i].src!=rdr.removeR(imgs[i].src)) {
              showedHosts=rdr.addMenuItem(ev,imgs[i].getAttribute(origSrc?"origsrc":'src'),imgs[i],showedHosts);
              hasItems=true;
            }
          }
    		}
      }  
    } catch(e) { rdr.d('Unsupported document type'); }
    
    if(!hasItems) {
      item = document.createElement("menuitem");
      if(rdr.is20) item.setAttribute("tooltiptext", rdr.locale.getString('buttonNords')); // Firefox 2.0 Bug Workaround 
      item.setAttribute("label", rdr.locale.getString('buttonNords'));
      item.setAttribute("disabled", "true");
      ev.appendChild(item);
    }
    
    ev.appendChild(document.createElement("menuseparator"));
    
    item = document.createElement("menuitem");
    if(rdr.is20) item.setAttribute("tooltiptext", rdr.locale.getString('buttonOpenoptions')); // Firefox 2.0 Bug Workaround 
    item.setAttribute("label", rdr.locale.getString('buttonOpenoptions'));
    item.setAttribute("accesskey", rdr.locale.getString('buttonOpenoptionsAccesskey'));
    item.setAttribute("oncommand", "rdr.openOptions();");
    ev.appendChild(item);
    
    item = document.createElement("menuitem");
    item.setAttribute("label", rdr.locale.getString('buttonEnablerdr'));
    if(rdr.is20) item.setAttribute("tooltiptext", rdr.locale.getString('buttonEnablerdr')); // Firefox 2.0 Bug Workaround 
    item.setAttribute("accesskey", rdr.locale.getString('buttonEnablerdrAccesskey'));
    item.setAttribute("oncommand", "rdr.prefs.setBoolPref('enabled',!rdr.enabled);");
    item.setAttribute("type", "checkbox");
    item.setAttribute("checked", rdr.enabled);
    ev.appendChild(item);

  },
  
  addMenuItem: function(ev,link,node,showedHosts) {
    host=rdr.getHost(link,node);
    rdr.d('Found '+host+' ('+link+')');
    if(showedHosts.indexOf(' '+host+' ')>=0) return showedHosts;
    showedHosts+=host+' ';          
    whtl=rdr.isWhitelisted(link,true);
    item = document.createElement("menuitem");
    item.setAttribute("id", "rdr-"+(whtl?'remove-from':'add-to')+"-list");
    item.setAttribute("class", "menuitem-iconic");
    item.setAttribute("label", whtl?whtl:host);
    item.setAttribute("tooltiptext", link);
    item.setAttribute("oncommand", (whtl?'rdr.removeLinkFromList':'rdr.addLinkToList')+'(this.getAttribute("tooltiptext"))');
    item.setAttribute("onclick", 'if(event.button==1) rdr.openOptions(this.getAttribute("tooltiptext")'+(whtl?',this.getAttribute("label")':'')+');');
    item.setAttribute("checked",whtl?'true':'false');
    ev.appendChild(item);
    return showedHosts;
  },
    
  contextMenuCheck: function(event) {
    if(event.target.getAttribute('id')!='contentAreaContextMenu' || !gContextMenu) return;
    if(rdr.origlinkURL == null) {
      link=gContextMenu.linkURL;
      isOnList=rdr.isWhitelisted(link);
      cleanedLink=rdr.removeR(link);
      containsR=gContextMenu.onLink && (link!=cleanedLink);
      if(containsR) {
        rdr.d('Extracted '+cleanedLink+' from '+link);
        rdr.origlinkURL=new Array(gContextMenu.link,link,isOnList,cleanedLink);
        if(rdr.enabled && !isOnList) {
          gContextMenu.linkURL=cleanedLink;
          gContextMenu.link.setAttribute("href",cleanedLink);
        }
      }
    } else {
      containsR=true;
      isOnList=rdr.origlinkURL[2];
    }
    rdr.hideById('rdr-copy-clean-link' ,(containsR && rdr.contextCopyClean));
    rdr.hideById('rdr-add-to-list'     ,(containsR && !isOnList && rdr.contextWhitelist));
    rdr.hideById('rdr-remove-from-list',(containsR &&  isOnList && rdr.contextWhitelist));
    rdr.hideById('rdr-open-cleaned'    ,(containsR && (!rdr.enabled || isOnList) && rdr.contextOpen));
    rdr.hideById('rdr-open-uncleaned'  ,(containsR && (rdr.enabled && !isOnList) && rdr.contextOpen));  
    
    if(containsR) {
      rdr.getById('rdr-open-cleaned').setAttribute("tooltiptext",unescape(cleanedLink));
      rdr.getById('rdr-open-uncleaned').setAttribute("tooltiptext",unescape(link));
      
      rdr.getById('rdr-copy-clean-link').setAttribute("tooltiptext",unescape(cleanedLink));
      
      rdr.getById('rdr-add-to-list').setAttribute("tooltiptext",rdr.getHost(link));
      rdr.getById('rdr-remove-from-list').setAttribute("tooltiptext",rdr.isWhitelisted(link,true));
    }
  },
  
  hideById: function(id,stat) {
    rdr.getById(id).hidden =!stat;
  },
  
  contextMenuClean: function(event) {
    if(event.target.getAttribute('id')=='contentAreaContextMenu') rdr.resetLink();
  },
  
  resetLink: function(dnd) {
    if(dnd) {
      if(!rdr.origlinkURL2) return;
      rdr.d('Cleaning DragDrop Link');
      rdr.origlinkURL2[0].setAttribute('href',rdr.origlinkURL2[1]);
      rdr.origlinkURL2=null;
    } else {
      if(!rdr.origlinkURL) return;
      rdr.d('Cleaning saved Link');
      rdr.origlinkURL[0].setAttribute('href',rdr.origlinkURL[1]);
      rdr.origlinkURL=null;    
    }
  },
  
  addLinkToList: function(link) {
    host=rdr.getHost(link);
    rdr.d('Added "'+host+' to list (from '+link+' )');
    if(!link || !host) return;
    wl=rdr.prefs.getCharPref("whitelist");
    if(wl.length>0) wl=wl+' ';
    rdr.prefs.setCharPref('whitelist',(wl+host).toLowerCase());
  },
  
  removeLinkFromList: function(link) {
    if(!link || !link.length) return;
    
    try {
      rdr.menu.hidePopup();
    } catch(e) {}
    
    var filter=rdr.isWhitelisted(link,true);    
    var wl=' '+rdr.prefs.getCharPref("whitelist")+' ';
    
    if(rdr.askBeforeRemoval) {
      prompts = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);
      flags = prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_IS_STRING + prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_CANCEL;
      check={value: true};
      cancelled = prompts.confirmEx(window, rdr.locale.getString('confirmRemoval'), rdr.locale.getFormattedString('confirmRemovalText', [filter]), flags, rdr.locale.getString('confirmRemovalBtn'), "", "", rdr.locale.getString('confirmRemovalAskBefore'), check);
      if(!cancelled && !check.value) rdr.prefs.setBoolPref('askBeforeRemoval',false);
    } else cancelled=false;
    
    if(filter && !cancelled) {
      rdr.d('Removing '+filter+' from list (from '+link+' )');
      rdr.prefs.setCharPref('whitelist',(wl.replace(' '+filter+' ',' ')).replace(/^\s*|\s*$/g,""));
      return;
    }
    
    rdr.d('Removing '+link+' from list failed; cancelled or no matching host found');
  },
  
  copyCleanLink: function() {
    var oCB = Cc["@mozilla.org/widget/clipboardhelper;1"].getService(Ci.nsIClipboardHelper);
    oCB.copyString(rdr.origlinkURL[3]);
  },
  
  openLink: function(link, node) {
    // Execute JS Links in page context
    if(link.indexOf("javascript:")==0 && node) {
      rdr.resetLink();
      var event = document.createEvent("MouseEvents");
      event.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
      // prevent RDR from intercepting
      rdr.preventClean=true;
      node.dispatchEvent(event);
      rdr.preventClean=false;
      return;
    }
    switch (rdr.contextOpenIn) {
      case 0: // here
        loadOneOrMoreURIs(link);
        break;
      case 2: // new window
        window.open(link);
        break;
      default: // new tab
        var t = gBrowser.addTab(link);
        if(!rdr.prefServ.getBoolPref('browser.tabs.loadInBackground')) {
          gBrowser.selectedTab = t;
          content.focus();
        }
    }
  },
  
  cleanLink: function(link) {
    if(!rdr.matchLinkFast(link) || rdr.isWhitelisted(link)) return link;     
    l=rdr.removeR(link,true);
    return l;
  },
  
  isWhitelisted: function(link,returnFilter) {  
    // rdr.blacklist defaults to false thus it works as whitelist. Switching it... obvious isn't it?  
    if(rdr.whitelist.length==0 || !link || link.length==0) return rdr.blacklist;
    var link=link.toLowerCase();
    for (var i=0;i<rdr.whitelist.length;i++) {
      var listParts=rdr.whitelist[i].split('*');
      var link2=(listParts[0].match(/^[a-z]+:\/\//)?unescape(link):rdr.getHost(link)); 
      var matches=true;
      z=0;
      for (var j in listParts) {
        var x=link2.indexOf(listParts[j]);
        if(x==-1 || x<z) { // not found or not in correct order
          matches=false;
          break;
        } 
        z=x+listParts[j].length;        
      }
      if(matches) {
        if(returnFilter) return rdr.whitelist[i];
        return !rdr.blacklist;
      }
    }
    return rdr.blacklist;  
  },
    
  getHost: function (link,node) {
    if(node) link=makeURLAbsolute(node.baseURI, link);  
    link=link.toLowerCase();
    var js=link.match(/^javascript:[a-z0-9%]+/ig);
    if(js && js[0].length) return js[0];
		try {
		  var url=link.match(/^([a-z0-9]+):\/\/(.*?)(?:\/|\?|$)/i);
      if(url[1]=="abp" || url[1]=="file") return url[1]+"://";
      return (url && url[2].length? url[2] : "");
	  } catch(e) {
		  return "";
		}
  },
  
  neverClean: function(link) {
    return link.match(/^mailto:|data:/i);
  },
  
  removeR: function(link,intel) {
    var test=link;
    if(rdr.neverClean(test)) return link;
    
  	test=rdr.matchLink(test);
    if(!test) return link;
    test=test.replace(/&amp;/g,'&');
    
    if(intel && rdr.intelliWhitelist && rdr.getHost(test)==rdr.getHost(link)) {
      rdr.d('Redirecting to itself: '+rdr.getHost(test)+' from '+link);
      return link;
    }    
    
    return test;
  },
  
  matchLink: function(link) {
    var re = new RegExp;
    // Check for rot13
    if(link.match(/(?:uggcf?|sgc)(?::\/\/|%3a%2f%2f|%253a%252f%252f)/i)) link=rdr.deRot13(link); 
    
    // Try to extract
  	re.compile(".+((?:https?|ftp)(?:(?::[^?]+[?][^=&]+=.+)|(?:(?:%3a|%253a|:)[^&]+)))", "gi");

  	if(!link.match(re)) {  
      // If failed, try base64
      if(link.match(/((?:[aS][FH]R[0U][cU][HF]?(?:DovL|M6Ly|CUz[QY]SUy[RZ]iUy[RZ]|MlM[02]ElM[mk]YlM[km])|[RZ][ln]R[Qw](?:Oi8v|JTN[Bh]JTJ[Gm]JTJ[Gm]))[a-zA-Z0-9+/]+)/))
        return unescape(atob(RegExp.$1));
        
      // Give up
      return false;
    }
    
    var ret=rdr.unesc(RegExp.$1);

    if (link.toLowerCase().indexOf('javascript') == 0) {
      var ulink=rdr.unesc(link);
      // Find opening quotationmark and match accordingly
      if(ulink.lastIndexOf("'",ulink.indexOf(ret)) > ulink.lastIndexOf('"',ulink.indexOf(ret))) 
        ret.match(/([\w$-.+!*()@:?=&\/;]+).*'.*$/gi);
      else
        ret.match(/([\w$-.+!*'()@:?=&\/;]+).*".*$/gi);
      return RegExp.$1;
    }
    
    return ret;
  },
  
  matchLinkFast: function(link) {
    if(!rdr.enabled || rdr.neverClean(link) || rdr.isWhitelisted(link)) return false;
    // Check for the possibilty of a redirect, don't care for correctness
    link=unescape(unescape(link));
    return link.match(/.+(?:(?:uggcf?|sgc|https?|ftp):\/\/)|(?:[aS][FH]R[0U][cU][HF]?|[RZ][ln]R[Qw])/i);
  },
  
  unesc: function(link) {
    var link = unescape(link);
    if (link.indexOf('%253a')) link = unescape(link);
    return link;
  },
   
  _rot13a: "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",
  _rot13b: "nopqrstuvwxyzabcdefghijklmNOPQRSTUVWXYZABCDEFGHIJKLM",
  deRot13: function(r) {
    var risp='';
    for(i=0; i<r.length; i++) {
      t = r.substr(i,1);
      x = rdr._rot13a.indexOf(t);
      risp += x > -1 ? rdr._rot13b.substr(x,1) : t;
    }
    return risp;
  },
    
  observe: function (subject, topic, data) {
		if (topic == "nsPref:changed") {
			rdr.updatePrefs();
		}
	},
    
  openOptions: function(link,filter) {
    window.openDialog('chrome://rdr/content/prefs.xul','','chrome,modal,resizable,centerscreen',link,filter);
  },
  
  globalc: 0,  
	d: function(t) {
    rdr.globalc++;
	  if(rdr.debug) Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage(rdr.globalc+' RDR: '+t);
  }
}